#include <iostream>
#include <vector>
#include <map>
#include <deque>

using namespace std;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif // DEBUG

typedef long long LL;
typedef long double LD;
#define MP make_pair

struct st{
    int v, inc, t, cnt;
    st(){}
    st(int v, int inc, int t, int cnt): v(v), inc(inc), t(t), cnt(cnt){}
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,k;
    cin >> n >> k;
    if(k == n) {
        cout << 1 << endl;
    }
    deque<st> d;
    for(int i = 1; k + i <= n; i++) {
        if(i < k){
            d.push_back(st(k + i, i, 0, 1));
        } else if(i > k){
            d.push_back(st(k + i, i, 1, 1));
        }
    }
    //map<pair<int,int> ex;
    LL ans = 0;
    while(!d.empty()){
        st u = d.front();
        //cout << u.v << ' ' << u.inc << endl;
        d.pop_front();
        if(u.v > n) continue;
        if(u.v == n){
            ans += u.cnt;
            continue;
        }
        if(u.t == 1) {
            for(int i = 1; i < u.inc; i++) {
                d.push_back(st(u.v + i, i, 0, 1));
            }
        }else{
            for(int i = u.inc + 1; u.v + i <= n; i++) {
                d.push_back(st(u.v + i, i, 1, 1));
            }
        }
    }
    cout << ans << endl;
    return 0;
}

/*
4
2 4 2 1
-- 2
3
2 -1 2
-- 2
3
-1 1 2
-- 2
6
-1 1 2 1 1 1
*/
