#include <iostream>
#include <vector>
#include <map>

using namespace std;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif // DEBUG

typedef long long LL;
typedef long double LD;
#define MP make_pair

vector<vector<int> > used;
vector<vector<int> > a;
vector<vector<int> > dp;

void dfs(int t, int v) {
    if(!used[t][v]){
        used[t][v] = 1;
        dp[t][v] += t;
        for(int i = 0; i < a[v].size(); i++) {
            dfs(!t, a[v][i]);
            dp[t][v] += dp[!t][a[v][i]];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    dp.resize(2, vector<int> (n, 0));
    used.resize(2, vector<int>(n, 0));
    for(int i = 0; i < n; i++) {
        int x;
        cin >> x;
        x--;
        if(x != -2){
            a[x].push_back(i);
            a[i].push_back(x);
        }
    }
    LL ans = 0;
    for(int i = 0; i < n; i++) {
        if(!used[0][i]){
            dfs(0,i);
            dfs(1,i);
            ans += max(dp[0][i], dp[1][i]);
        }
    }
    cout << ans;
    return 0;
}
