#include <iostream>
#include <math.h>

#define GCC optimise("03")

//#define DEBUG
#ifdef DEBUG
#include "Debug.h"
#endif // DEBUG

using namespace std;

typedef long long LL;
typedef long double LD;

int main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    LL k;
    cin >> k;
    if(k == 0){
        cout << 0;
        return 0;
    }
    LL n = sqrt(k)+1;
    if((n-1)*(n-1) == k){
        cout << n-1;
        return 0;
    }
    if((k>0 && k % 2 == 1) || (k < 0 && (-k) % 2 == 1)){
        for(int i = sqrt(k); i > 0; i--){
            if(k % i == 0) {
                cout << (i+k/i)/2;
                break;
            }
        }
    }else{
        LL tk = k;
        int cnt = 0;
        while (tk > 2) {
            n = sqrt(tk) + 1 + cnt;
            LL t = n * n - k;
            if((LL)sqrt(t) * (LL)sqrt(t) == t){
                cout << n;
                break;
            }
            tk /= 2;
            cnt++;
        }
        cout << cnt << endl;
        if(tk <= 2){
            cout << "none";
        }
    }
    return 0;
}
