#include <iostream>
#include <math.h>

#define GCC optimise("03")

//#define DEBUG
#ifdef DEBUG
#include "Debug.h"
#endif // DEBUG

using namespace std;

typedef long long LL;
typedef long double LD;

int main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    LL k;
    //for(int k = 0; k < 100; k++){
    cin >> k;
    if(k == 0){
        cout << 0;
        return 0;
        //continue;
    }
    if(k > 0){
        LL n = sqrt(k);
        if(n * n == k){
            cout << n;
            return 0;
            //continue;
        }
        if(k % 2 == 1){
            for(int i = sqrt(k); i > 0; i--){
                if(k % i == 0) {
                    cout << (i+k/i)/2;
                    break;
                }
            }
        }else{
            bool key = false;
            for(int i = sqrt(k); i > 0; i--){
                if(k % i == 0 && i % 2 == 0 && k / i % 2 == 0) {
                    cout << (i + k / i) / 2;
                    key = true;
                    break;
                }
            }
            if(!key){
                cout << "none";
            }
        }
    }else{
        k = -k;
        LL n = sqrt(k);
        if(n * n == k){
            cout << 0;
            return 0;
            //continue;
        }
        if(k % 2 == 1){
            for(int i = sqrt(k); i > 0; i--){
                if(k % i == 0) {
                    cout << (i + k / i) / 2-i;
                    break;
                }
            }
        }else{
            bool key = false;
            for(int i = sqrt(k); i > 0; i--){
                if(k % i == 0 && i % 2 == 0 && k / i % 2 == 0) {
                    cout << (i+k/i)/2-i;
                    key = true;
                    break;
                }
            }
            if(!key){
                cout << "none";
            }
        }
    }
    //}
    return 0;
}
/*
0 - 0
1 - 1
2 - none
3 - 2
4 - 2
5 - 3
6 - none
7 - 4
8 - 3
9 - 3
10 - none
11 - 6
12 - 4
13 - 7
14 - none
15 - 4
16 - 4
17 - 9
18 - none
19 - 10
20 - none
21 - 5
22 - none
23 - 12
24 - 5
25 - 5
26 - none
27 - 6
28 - none
29 - 15
30 - none
31 - 16
32 - 6
33 - 7
34 - none
35 - 6
36 - 6
37 - 19
38 - none
39 - 8
40 - 7
41 - 21
42 - none
43 - 22
44 - none
45 - 7
46 - none
47 - 24
48 - 7
49 - 7
50 - none
51 - 10
52 - none
53 - 27
54 - none
55 - 8
56 - none
57 - 11
58 - none
59 - 30
60 - 8
61 - 31
62 - none
63 - 8
64 - 8
65 - 9
66 - none
67 - 34
68 - none
69 - 13
70 - none
71 - 36
72 - 9
73 - 37
74 - none
75 - 10
76 - none
77 - 9
78 - none
79 - 40
80 - 9
81 - 9
82 - none
83 - 42
84 - 10
85 - 11
86 - none
87 - 16
88 - none
89 - 45
90 - none
91 - 10
92 - none
93 - 17
94 - none
95 - 12
96 - 10
97 - 49
98 - none
99 - 10
*/
