#include <iostream>
#include <math.h>

#define GCC optimise("03")

//#define DEBUG
#ifdef DEBUG
#include "Debug.h"
#endif // DEBUG

using namespace std;

typedef long long LL;
typedef long double LD;

int main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    LL k;
    cin >> k;
    if(k == 0){
        cout << 0;
        return 0;
    }
    LL n = sqrt(k)+1;
    if((n-1)*(n-1) == k){
        cout << n-1;
        return 0;
    }
    if((k>0 && k % 2 == 1) || (k < 0 && (-k) % 2 == 1)){
        LL t = n*n-k;
        if((LL)sqrt(t)*(LL)sqrt(t) == t){
            cout << n;
        }else{
            cout << (k+1)/2;
        }
    }else{
        LL tk=k;
        int cnt = 0;
        while(tk/2%2==0){
            tk/=2;
            cnt++;
        }
        tk = min(tk * 2, k);
        cnt = max(cnt - 1, 0);
        //cout << cnt << endl;
        n=sqrt(tk)+1+cnt;
        LL t = n*n-k;
        if((LL)sqrt(t)*(LL)sqrt(t)==t){
            cout << n;
        }else{
            cout << "none";
        }
    }
    return 0;
}
