#include <iostream>
#include <math.h>
#include <queue>
#include <map>

#define GCC optimise("03")

#define DEBUG
#ifdef DEBUG
#include "Debug.h"
#endif // DEBUG

using namespace std;

typedef long long LL;
typedef long double LD;

int main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    int n,m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(m);
    map<int,queue<int> > mp;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < m; i++) {
        cin >> b[i];
        mp[b[i]].push(i-1);
    }
    vector<int> ans;
    for(int i = 0; i < m; i++) {
            DP(a);
        while(a[0]!=b[i]){
            LL t = a[0];
            LL tt = n;
            if(mp.find(t) != mp.end()){
                mp[t].pop();
                tt = mp[a[0]].front();
                ans.push_back(tt);
            }
            for(int i = 0; i < tt-1; i++) {
                a[i] = a[i+1];
            }
            a[tt-1] = t;
            DP(a);
        }
    }
    cout << ans.size() << endl;
    for(int i = 0; i < ans.size(); i++) {
        cout << ans[i] << ' ';
    }
    return 0;
}
/*
4 4
1 2 3 4
4 3 2 1
*/
