#include <iostream>
#include <vector>
#include <map>

using namespace std;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif // DEBUG

typedef long long LL;
typedef long double LD;
#define MP make_pair

vector<int> used;
vector<vector<int> > a;
vector<vector<int> > dp;
vector<LL> dist;

LL dfs(int v, LL sz) {
    if(!used[v]){
        used[v] = 1;
        for(int i = 0; i < a[v].size(); i++) {
            if(!used[a[v][i]]){
                sz += dfs(a[v][i],1);
            }
        }
    }
    return sz;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    dp.resize(2, vector<int> (n, 0));
    used.resize(n,0);
    for(int i = 0; i < n; i++) {
        int x;
        cin >> x;
        x--;
        if(x != -2){
            a[x].push_back(i);
            a[i].push_back(x);
        }
    }
    LL ans = 0;
    for(int i = 0; i < n; i++) {
        if(!used[i]){
            ans += (dfs(i, 1) + 1) / 2;
        }
    }
    cout << ans;
    return 0;
}

/*
4
2 4 2 1
-- 2
3
2 -1 2
-- 2
3
-1 1 2
-- 2
6
-1 1 2 1 1 1
*/
