#include <iostream>
#include <vector>
#include <map>

using namespace std;

//#define DEBUG
#ifdef DEBUG
#include "debug.h"
#endif // DEBUG

typedef long long LL;
typedef long double LD;
#define MP make_pair

int cnt;

vector<int> a;
vector<vector<bool> > used;
vector<LL> dp0;
vector<LL> dp1;
vector<int> cn;
vector<LL> dpa;

void dfs(int t, int v, map<pair<int,int>,int > &uoc) {
    if(used[t][v]) return;
    if(uoc.find(MP(t, v)) != uoc.end()) return;
    cn[v] = cnt;
    used[t][v] = 1;
    uoc[MP(t,v)] = 1;
    if(t){
        if(a[v] == -1){
            dp1[v] = 1;
        }else{
            if(uoc.find(MP(1, a[v])) != uoc.end()){
                dp1[v] = 0;
            }else{
                dfs(0, a[v],uoc);
                dp1[v] = dp0[a[v]] + 1;
            }
        }
    }else{
        if(a[v] == -1){
            dp0[v] = 0;
        }else{
            if(uoc.find(MP(0, a[v])) == uoc.end()){
                dfs(1, a[v],uoc);
                dp0[v] = dp1[a[v]];
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    used.assign(2, vector<bool> (n, 0));
    dp0.assign(n, 0);
    dp1.assign(n, 0);
    cn.assign(n,0);
    dpa.assign(n, 0);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        if(a[i] != -1) a[i]--;
    }
    //DO(a);
    cnt = 0;
    for(int i = 0; i < n; i++) {
        map<pair<int,int>, int> uoc;
        if(!used[0][i] && !used[1][i]){
            bool key = false;
            if(a[i] != -1 && used[0][a[i]]){
                key = true;
            }
            dfs(1, i, uoc);
            uoc.clear();
            dfs(0, i, uoc);
            if(key) cn[i] = cn[a[i]];
            int v = a[i];
            bool sw = 0;
            while(v != -1 && v != i && (uoc.find(MP(0,v)) != uoc.end() || uoc.find(MP(1,v)) != uoc.end())){
                if(sw){
                    dp0[v] = dp0[i];
                    dp1[v] = dp1[i];
                }else{
                    dp0[v] = dp1[i];
                    dp1[v] = dp0[i];
                }
                sw = !sw;
                v = a[v];
            }
            if(a[i] != -1){
                dpa[cn[a[i]]] = 0;
            }
            dpa[cn[i]] = max(dp1[i], dp0[i]);
        }
        cnt++;
        /*
        DO(used);
        DO(dpa);
        DO(dp0);
        DO(dp1);
        DO(cn);
        DP(333333333);
        */
    }
    LL ans = 0;
    for(int i = 0; i < n; i++) {
        ans += dpa[i];
    }
    cout << ans << endl;
    return 0;
}
/*
4
2 4 2 1
-- 2
3
2 -1 2
-- 2
3
-1 1 2
-- 2
6
-1 1 2 3 4 5
*/
